"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class UniparentalDisomy(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "assembly",
        "chromosome",
        "origin",
        "participantId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "uniparentalDisomyEvidences": reports_6_5_0.UniparentalDisomyEvidences,
            "uniparentalDisomyFragments": reports_6_5_0.UniparentalDisomyFragment,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "assembly": reports_6_5_0.Assembly,
            "origin": reports_6_5_0.UniparentalDisomyOrigin,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "org.gel.models.report.avro.Assembly": reports_6_5_0.Assembly,
            "org.gel.models.report.avro.UniparentalDisomyOrigin": reports_6_5_0.UniparentalDisomyOrigin,
            "org.gel.models.report.avro.UniparentalDisomyEvidences": reports_6_5_0.UniparentalDisomyEvidences,
            "org.gel.models.report.avro.UniparentalDisomyFragment": reports_6_5_0.UniparentalDisomyFragment,
            "org.gel.models.report.avro.UniparentalDisomy": reports_6_5_0.UniparentalDisomy,
        }

    __slots__ = [
        "assembly",
        "chromosome",
        "origin",
        "participantId",
        "complete",
        "uniparentalDisomyEvidences",
        "uniparentalDisomyFragments",
    ]

    def __init__(
        self,
        assembly,
        chromosome,
        origin,
        participantId,
        complete=None,
        uniparentalDisomyEvidences=None,
        uniparentalDisomyFragments=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_5_0.UniparentalDisomy model.

        :param assembly:
            The assembly
        :type assembly: Assembly
        :param chromosome:
            Chromosome where two homologues were inherited from one parent
        :type chromosome: str
        :param origin:
            The parent who contributed two chromosomes was the mother (maternal)
            or the father (paternal)
        :type origin: UniparentalDisomyOrigin
        :param participantId:
            Participant affected by this UPD
        :type participantId: str
        :param complete:
            indicates Whether the UPD event involves an entire chromosome or part
            of a chromosome
        :type complete: None | boolean
        :param uniparentalDisomyEvidences:
            Evidences for the UPD call
        :type uniparentalDisomyEvidences: None | UniparentalDisomyEvidences
        :param uniparentalDisomyFragments:
            List of all of the UPD fragments for this UPD event
        :type uniparentalDisomyFragments: None | list[UniparentalDisomyFragment]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.5.0"
